<cfcomponent output="false">

	<cfscript>
	    THIS.name="AIRUpdateManager";
	</cfscript>
	
	<cffunction name="onApplicationStart">
	
		<!---
		APPLICATION VARIABLES
		--->
		<cfset APPLICATION.dsn="updateManager" />
		<cfset APPLICATION.airApplicationDirectory="C:\ColdFusion8\airApps" />
		<cfset APPLICATION.fileDownloadURL="http://localhost:8500/UpdateManager/serve.cfm" />
	
		<cfscript>
			objSystem = createObject("java", "java.lang.System");
			Application.fileSeparator = objSystem.getProperty("file.separator");
		</cfscript>
		
		<cftry>
		
			<cfquery name="dbTest" datasource="#APPLICATION.dsn#">
				SELECT applicationID FROM versions
			</cfquery>
		
			<cfcatch type="database">
			
				<cfset dbCreated = createTables() />
			
				<cfif dbCreated EQ false>
				
					<cfrethrow />
				
				</cfif>
			
			</cfcatch>
		
		</cftry>
		
		<cfreturn true />
	
	</cffunction>

	<cffunction name="onRequestStart" returnType="boolean" output="false">
		<cfargument name="page" type="string" required="true" />
		
		<cfif structKeyExists(url, "reset")>
			<cfset onApplicationStart() />
		</cfif>
		
		<cfreturn true />
	</cffunction>
	
	<cffunction name="createTables">
		
		<cftry>

			<cfquery name="createVersionsTable" datasource="#APPLICATION.dsn#">
				CREATE TABLE versions (
					 uuid VARCHAR(36) NOT NULL,
					 dateTimeCreated TIMESTAMP NOT NULL,
					 applicationID VARCHAR(255),
					 version VARCHAR(20),
					 name VARCHAR(255),
					 updateType INT NOT NULL,
					 updateFile VARCHAR(255),
					 releaseNotes LONG VARCHAR,
					 PRIMARY KEY (uuid)
					 )
			</cfquery>
			
			<cfcatch type="database">
				
				<cfreturn false />
			
			</cfcatch>
		
		</cftry>
		
		<cfreturn true />
	
	</cffunction>

<cfsetting showdebugoutput="No" enablecfoutputonly="No">
</cfcomponent>