<cfcomponent name="UpdateManager" output="false">
	
	<cfset THIS.UPDATE_AVAILABLE = 1 />
	<cfset THIS.APPLICATION_NOT_FOUND = 2 />
	<cfset THIS.APPLICATION_CURRENT = 3 />
	
	<cffunction name="getUpdateJSON" access="remote" returntype="struct" returnformat="json" output="false">		
		<cfargument name="applicationID" type="String" required="true" />
		<cfargument name="currentVersion" type="String" default="" />
		
		<cfreturn getLatestVersion(ARGUMENTS.applicationID,ARGUMENTS.currentVersion) />
	
	</cffunction>

	<cffunction name="getLatestVersion" access="private" returnType="struct">
		<cfargument name="applicationID" type="String" required="true" />
		<cfargument name="currentVersion" type="String" default="" />		
		
		<cfset var returnStruct = StructNew() />
		<cfset returnStruct.updateInfo = StructNew() />
		
		<cfif Len(trim(ARGUMENTS.currentVersion))>
		
			<cfquery name="applicationVersionQuery" datasource="#APPLICATION.dsn#">
				SELECT * FROM versions WHERE
					applicationID = <cfqueryparam cfsqltype="cf_sql_varchar" value="#ARGUMENTS.applicationID#" /> AND
					version = <cfqueryparam cfsqltype="cf_sql_varchar" value="#ARGUMENTS.currentVersion#" />					
			</cfquery>
			
			<cfif applicationVersionQuery.RecordCount NEQ 1>
				<cfset returnStruct.updateCode=THIS.APPLICATION_NOT_FOUND />
				<cfreturn returnStruct />
			</cfif>
		
		</cfif>
		
		<cfquery name="applicationQuery" datasource="#APPLICATION.dsn#">
			SELECT * FROM versions WHERE dateTimeCreated =
				(
					SELECT MAX(dateTimeCreated) FROM versions WHERE applicationID = 
						<cfqueryparam cfsqltype="cf_sql_varchar" value="#ARGUMENTS.applicationID#" /> 
					
						<cfif Len(trim(ARGUMENTS.currentVersion))>
							AND dateTimeCreated > 
							<cfqueryparam cfsqltype="cf_sql_timestamp" value="#applicationVersionQuery.dateTimeCreated#" />
						</cfif>
				) 
				AND applicationID = <cfqueryparam cfsqltype="cf_sql_varchar" value="#ARGUMENTS.applicationID#" />
		</cfquery>	
		
		<cfif applicationQuery.RecordCount EQ 1>
			<cfset returnStruct.updateInfo.updateVersion=applicationQuery.version />
			<cfset returnStruct.updateInfo.updateURL=APPLICATION.fileDownloadURL & "?id=" & applicationQuery.uuid />
			<cfset returnStruct.updateInfo.updateType=applicationQuery.updateType />
			<cfset returnStruct.updateInfo.releaseNotes=applicationQuery.releaseNotes />
			<cfset returnStruct.updateCode=THIS.UPDATE_AVAILABLE />
		<cfelse>
			<cfset returnStruct.updateCode=THIS.APPLICATION_CURRENT />
		</cfif>
		
		<cfreturn returnStruct />
		
	</cffunction>
	
</cfcomponent>
