<html>
<head>
<title>AIR Update Manager - Add an Application</title>
</head>
<body>
<!--- Check to see if the Form variable exists. --->
<cfif isDefined("Form.FileContents") >
	
	<!---
	UPLOAD THE AIR FILE
	--->
	<cffile action = "upload" 
		fileField = "FileContents"
		destination = "#APPLICATION.airApplicationDirectory#" 
		nameConflict = "MakeUnique">
	
	<!---
	READ IN THE AIR FILE
	--->	
	<cfset airFile= APPLICATION.airApplicationDirectory & APPLICATION.fileSeparator & cffile.serverFile />
	
	<cfzip action="read"
		file="#airFile#"
		entrypath="META-INF#APPLICATION.fileSeparator#AIR#APPLICATION.fileSeparator#application.xml"
		variable="applicationDescriptor" />

	<cfset appDescriptor = XmlParse(applicationDescriptor,true) />

	<!---
	DEFINE AIR APP VARIABLES
	--->
	<cfset appID = appDescriptor['application']['id'].XMLText />
	<cfset appVersion = appDescriptor['application']['version'].XMLText />
	<cfset appName = appDescriptor['application']['name'].XMLText />
	
	<!---
	CHECK TO SEE IF THIS VERSION OF THE APPLICATION IS ALREADY IN DB
	--->
	<cfquery name="ifDuplicate" datasource="#APPLICATION.dsn#">
		SELECT * FROM versions WHERE
			applicationID  = <cfqueryparam cfsqltype="cf_sql_varchar" value="#VARIABLES.appID#"> AND
			version = <cfqueryparam cfsqltype="cf_sql_varchar" value="#VARIABLES.appVersion#">
	</cfquery>

	<cfif ifDuplicate.RecordCount NEQ 0>
		<cfset variables.message="Application Version Already in Database" />
	<cfelse>

		<!---
		ATTEMPT TO ADD APPLICATION TO DB
		--->
		<cftry>
			
			<cfquery name="addApplicationUpdate" datasource="#APPLICATION.dsn#">
				INSERT INTO versions (uuid,dateTimeCreated,applicationID,version,name,updateType,updateFile,releaseNotes)
					VALUES (
						'#CreateUUID()#',
						<cfqueryparam cfsqltype="cf_sql_timestamp" value="#DateFormat(now())# #TimeFormat(now())#">,
						<cfqueryparam cfsqltype="cf_sql_varchar" value="#VARIABLES.appID#">,
						<cfqueryparam cfsqltype="cf_sql_varchar" value="#VARIABLES.appVersion#">,
						<cfqueryparam cfsqltype="cf_sql_varchar" value="#VARIABLES.appName#">,
						<cfqueryparam cfsqltype="cf_sql_integer" value="#FORM.updateType#">,
						<cfqueryparam cfsqltype="cf_sql_varchar" value="#cffile.serverFile#">,
						<cfqueryparam cfsqltype="cf_sql_longvarchar" value="#FORM.releaseNotes#">
						)
			</cfquery>
			
			<cfset variables.message="Application Added" />

			<!---
			IF THERE IS A PROBLEM ADDING TO ITEM TO THE DB
			--->			
			<cfcatch type="database">
				<cfset variables.message="Database Error" />
			</cfcatch>
		
		</cftry>
	
	</cfif>
	
	<cfoutput><p><strong>#variables.message#</strong></p></cfoutput>
	
</cfif>

<!---
THE ENTRY FORM
--->
<form method="post" name="uploadForm" enctype="multipart/form-data">
	
	AIR File<br />
	<input name="FileContents" type="file"><br />
	<br />
	Update Type:<br />
	<select name="updateType">
		<option value="0">Critical</option>
		<option value="1">Major</option>
		<option value="2">Minor</option>
	</select><br />
	<br />
	Release Notes:<br />
	<textarea name="releaseNotes"></textarea><br />
	<br />		
	<input name="submit" type="submit" value="Upload File"><br />
	
</form>

</body>
</html>


