package net.davidtucker.air.update {
	
	public class AIRUpdate {
		
		public static const CRITICAL_UPDATE:uint = 0;
		public static const MAJOR_UPDATE:uint = 1;
		public static const MINOR_UPDATE:uint = 2;
		
		private var _releaseNotes:String;
		
		public function get releaseNotes():String {
			return _releaseNotes;
		}
		
		private var _updateStatus:int;
		
		public function get updateStatus():int {
			return _updateStatus;
		}
		
		private var _updateURL:String;
		
		public function get updateURL():String {
			return _updateURL;
		}
		
		private var _updateVersion:String;
		
		public function get updateVersion():String {
			return _updateVersion;
		}
		
		public function AIRUpdate(obj:Object = null) {
			
			this._releaseNotes = obj.RELEASENOTES;
			this._updateStatus = obj.UPDATETYPE;
			this._updateVersion = obj.UPDATEVERSION;
			this._updateURL = obj.UPDATEURL;
					
		}
		
		public function toString():String {
			
			var output:String = "[Update Version: " + this._updateVersion
				+ " Update	URL: " + this._updateURL + " UpdateStatus: " + statusString(this._updateStatus)
				+ " Release Notes: " + this._releaseNotes + "]";
			
			return output;
								
		}
		
		private function statusString(val:int):String {
			
			var output:String = "";
			
			switch(val) {
						
				case AIRUpdate.CRITICAL_UPDATE:
					 output = "Critical";
					break;
				
				case AIRUpdate.MAJOR_UPDATE:
					 output = "Major";
					break;
					
				case AIRUpdate.MINOR_UPDATE:
					 output = "Minor";
					break;
				
			}
			
			return output;
					
		}
		
	}
}